package concurrency.week04;

import java.util.LinkedList;
import java.util.List;

abstract class Resource {

	protected int num = 0;
	protected List<Integer> history = new LinkedList<Integer>();
	protected boolean broken = false;

	protected abstract boolean produce();

	protected abstract boolean consume();

	String getHistory() {
		StringBuffer sb = new StringBuffer();
		int j = 0;
		for (Integer i : history) {
			if (i < 0) {
				sb.append("ERROR!!");
				break;
			}
			sb.append(i);
			sb.append(", ");
			if (j == 15) {
				sb.append('\n');
				j = 0;
			}
			else{
				j++;
			}
		}
		return sb.toString();
	}
	
}