package concurrency.week04;

class Resource2 extends Resource {

	@Override
	protected synchronized boolean produce() {
		if (broken) {
			return false;
		}
		num++;
		history.add(num);

		notify(); // Added to Resource1

		return true;
	}

	@Override
	protected synchronized boolean consume() {
		if (broken) {
			return false;
		}

		if (!(num > 0)) {
			try {
				wait(); // Added to Resource1
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
		}

		if (num > 0) {
			num--;
			history.add(num);
			return true;
		} else {
			System.out.println("Error: consume from zero!");
			history.add(num - 1);
			broken = true;
			return false;
		}
	}

}