package concurrency.week04;

class Consumer extends Worker {

	Consumer(Resource resource, int repeatNum) {
		super(resource, repeatNum);
	}

	@Override
	public void run() {
		for (int i = 0; i < repeatNum; i++) {
			if (!resource.consume()) {
				break;
			}
			try {
				Thread.sleep((long) (Math.random() * 200));
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
		}
	}

}