package concurrency.week04;

import java.util.concurrent.Semaphore;

class Resource4 extends Resource {

	private Semaphore sem = new Semaphore(0);

	@Override
	protected boolean produce() {
		sem.release();
		synchronized (history) {
			history.add(sem.availablePermits());
		}
		return true;
	}

	@Override
	protected boolean consume() {
		try {
			sem.acquire();
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
		synchronized (history) {
			history.add(sem.availablePermits());
		}
		return true;
	}

}